searchData={"items":[{"type":"module","title":"EcspanseStateMachine","doc":"ECSpanse State Machine Api","ref":"EcspanseStateMachine.html"},{"type":"function","title":"EcspanseStateMachine.current_state/1","doc":"Retrieves the current state of the state machine in the given entity if it is running.","ref":"EcspanseStateMachine.html#current_state/1"},{"type":"function","title":"EcspanseStateMachine.format_as_mermaid_diagram/2","doc":"Generates the source for a [Mermaid State Diagram](https://mermaid.js.org)","ref":"EcspanseStateMachine.html#format_as_mermaid_diagram/2"},{"type":"function","title":"Parameters - EcspanseStateMachine.format_as_mermaid_diagram/2","doc":"- title: The diagram will have this title (optional)","ref":"EcspanseStateMachine.html#format_as_mermaid_diagram/2-parameters"},{"type":"function","title":"EcspanseStateMachine.new/3","doc":"Creates a [component_spec](https://hexdocs.pm/ecspanse/Ecspanse.Component.html#t:component_spec/0) for a State Machine","ref":"EcspanseStateMachine.html#new/3"},{"type":"function","title":"Options - EcspanseStateMachine.new/3","doc":"auto_start: boolean - if true, the state machine will start automatically","ref":"EcspanseStateMachine.html#new/3-options"},{"type":"function","title":"Examples - EcspanseStateMachine.new/3","doc":"state_machine =\n      EcspanseStateMachine.new(:red, [\n        [name: :red, exits: [:green, :flashing_red], timeout: 30_000],\n        [name: :flashing_red, exits: [:red]],\n        [name: :green, exits: [:yellow], timeout: 10_000, default_exit: :yellow],\n        [name: :yellow, exits: [:red]]\n      ])","ref":"EcspanseStateMachine.html#new/3-examples"},{"type":"function","title":"EcspanseStateMachine.project/1","doc":"Returns a map of the state_machine to use in your [projections](https://hexdocs.pm/ecspanse/Ecspanse.Projection.html).","ref":"EcspanseStateMachine.html#project/1"},{"type":"function","title":"EcspanseStateMachine.running?/1","doc":"Returns true/false if the state machine is running","ref":"EcspanseStateMachine.html#running?/1"},{"type":"function","title":"EcspanseStateMachine.setup/1","doc":"Registers the state machine systems with the ECSpanse manager.\n\nCall this from your setup(data) function. [See ECSpanse Setup](https://hexdocs.pm/ecspanse/getting_started.html#setup)","ref":"EcspanseStateMachine.html#setup/1"},{"type":"function","title":"Examples - EcspanseStateMachine.setup/1","doc":"def setup(data) do\n      data\n      |> EcspanseStateMachine.setup()\n      #\n      # Your registrations here\n      #\n      # Be sure to setup the Ecspanse.System.Timer if you have any 73s\n      |> Ecspanse.add_frame_end_system(Ecspanse.System.Timer)\n    end","ref":"EcspanseStateMachine.html#setup/1-examples"},{"type":"function","title":"EcspanseStateMachine.start/1","doc":"Starts the state machine","ref":"EcspanseStateMachine.html#start/1"},{"type":"function","title":"EcspanseStateMachine.stop/1","doc":"Stops the state machine","ref":"EcspanseStateMachine.html#stop/1"},{"type":"function","title":"EcspanseStateMachine.transition/4","doc":"Triggers a state change\n\n* the state machine is needs to be running\n* the from state must be the current state\n* the to state must be in the current state's exits","ref":"EcspanseStateMachine.html#transition/4"},{"type":"function","title":"Parameters - EcspanseStateMachine.transition/4","doc":"- from: the state to transition from\n  - to: the state to transition to\n  - trigger: the reason for the transition","ref":"EcspanseStateMachine.html#transition/4-parameters"},{"type":"function","title":"EcspanseStateMachine.transition_to_default_exit/3","doc":"Triggers a state change to the default exit\n\n* the state machine is needs to be running\n* the from state must be the current state\n* the from state must have an exit","ref":"EcspanseStateMachine.html#transition_to_default_exit/3"},{"type":"function","title":"Parameters - EcspanseStateMachine.transition_to_default_exit/3","doc":"- from: the state to transition from\n  - trigger: the reason for the transition","ref":"EcspanseStateMachine.html#transition_to_default_exit/3-parameters"},{"type":"type","title":"EcspanseStateMachine.state_name/0","doc":"state names can be an atom or a string","ref":"EcspanseStateMachine.html#t:state_name/0"},{"type":"module","title":"EcspanseStateMachine.Components.StateMachine","doc":"The state machine component tracks the running status and current state.","ref":"EcspanseStateMachine.Components.StateMachine.html"},{"type":"module","title":"Fields - EcspanseStateMachine.Components.StateMachine","doc":"* initial_state: the state the machine should be in at start\n* current_state: the state the machine is in now\n* states: keyword lists of states [:name, exits[:exit_state1, :exit_state2...], :timeout, :default_exit]\n* auto_start: if true, the machine will be automatically started","ref":"EcspanseStateMachine.Components.StateMachine.html#module-fields"},{"type":"function","title":"EcspanseStateMachine.Components.StateMachine.get_state_spec/2","doc":"Retrieves the keyword list with the provided name","ref":"EcspanseStateMachine.Components.StateMachine.html#get_state_spec/2"},{"type":"function","title":"EcspanseStateMachine.Components.StateMachine.validate/1","doc":"","ref":"EcspanseStateMachine.Components.StateMachine.html#validate/1"},{"type":"type","title":"EcspanseStateMachine.Components.StateMachine.state_name/0","doc":"state names can be an atom or a string","ref":"EcspanseStateMachine.Components.StateMachine.html#t:state_name/0"},{"type":"module","title":"EcspanseStateMachine.Events.Started","doc":"Emitted when a state machine starts","ref":"EcspanseStateMachine.Events.Started.html"},{"type":"module","title":"Fields - EcspanseStateMachine.Events.Started","doc":"* entity_id: the id of the entity with the state machine","ref":"EcspanseStateMachine.Events.Started.html#module-fields"},{"type":"module","title":"Examples - EcspanseStateMachine.Events.Started","doc":"%Started{entity_id: \"78d51554-83c6-4c66-b043-a5bd71a2f2ce\"}","ref":"EcspanseStateMachine.Events.Started.html#module-examples"},{"type":"module","title":"EcspanseStateMachine.Events.StateChanged","doc":"Emitted when the state has changed","ref":"EcspanseStateMachine.Events.StateChanged.html"},{"type":"module","title":"Fields - EcspanseStateMachine.Events.StateChanged","doc":"* entity_id: the id of the entity with the state machine\n* from: the previous state\n* to: the current state\n* trigger: the trigger for the transition (e.g. :timeout, :startup, :request)","ref":"EcspanseStateMachine.Events.StateChanged.html#module-fields"},{"type":"module","title":"Examples - EcspanseStateMachine.Events.StateChanged","doc":"%StateChanged{entity_id: \"78d51554-83c6-4c66-b043-a5bd71a2f2ce\",\n      from: \"Battle Start\",\n      to: \"Turn Start\",\n      trigger: :timeout}","ref":"EcspanseStateMachine.Events.StateChanged.html#module-examples"},{"type":"module","title":"EcspanseStateMachine.Events.Stopped","doc":"Emitted when a state machine is stopped","ref":"EcspanseStateMachine.Events.Stopped.html"},{"type":"module","title":"Fields - EcspanseStateMachine.Events.Stopped","doc":"* entity_id: the id of the entity with the state machine","ref":"EcspanseStateMachine.Events.Stopped.html#module-fields"},{"type":"module","title":"Examples - EcspanseStateMachine.Events.Stopped","doc":"%Stopped{entity_id: \"78d51554-83c6-4c66-b043-a5bd71a2f2ce\"}","ref":"EcspanseStateMachine.Events.Stopped.html#module-examples"},{"type":"extras","title":"EcspanseStateMachine","doc":"# EcspanseStateMachine\n\n[![Hex Version](https://img.shields.io/hexpm/v/ecspanse_state_machine.svg)](https://hex.pm/packages/ecspanse_state_machine)\n![GitHub CI](https://github.com/ketupia/ecspanse_state_machine/actions/workflows/elixir.yml/badge.svg)\n[![Documentation](https://img.shields.io/badge/documentation-gray)](https://hexdocs.pm/ecspanse_state_machine)\n\n<!-- [![License](https://img.shields.io/hexpm/l/ecspanse_state_machine.svg)](https://github.com/ketupia/ecspanse_state_machine/blob/72dd2045a8ca217b7b07529ac43780d0a3145e50/README.md) -->\n\n<!-- ![Elixir](https://img.shields.io/badge/dynamic/yaml?url=https://raw.githubusercontent.com/ketupia/ecspanse_state_machine/master/.github/workflows/elixir.yml&query=$.jobs.build.steps[1].with[\"elixir-version\"]&label=Elixir) -->\n\n`ECSpanse State Machine` is a component level state machine implementation for [`ECSpanse`](https://hexdocs.pm/ecspanse). It is an Ecspanse component you include in your entities.\n\n[![](https://mermaid.ink/img/pako:eNpVkDEOwjAMRa8SeUTNwpgBCYmFgYkRM0SNaSOStEpdJFT1DNyFifNwAa5Amg6UJcp7_pFjD1A2hkCBlBIDW3akxNH61pHY7jFkjaFjzbSzuoray9t6UqfVWUi5EdY4wnCxVc2Zjf3DuTydGXNhwa3m2Dgl3o_n5_XAMPMyujDTq180Nco2fQQK8BS9tiZNMmAQAoFr8oSg0tXoeEXAMKac7rk53kMJimNPBfSt-Y0G6qJdlywZy008zKvJGxq_xZBnJQ?type=png)](https://mermaid.live/edit#pako:eNpVkDEOwjAMRa8SeUTNwpgBCYmFgYkRM0SNaSOStEpdJFT1DNyFifNwAa5Amg6UJcp7_pFjD1A2hkCBlBIDW3akxNH61pHY7jFkjaFjzbSzuoray9t6UqfVWUi5EdY4wnCxVc2Zjf3DuTydGXNhwa3m2Dgl3o_n5_XAMPMyujDTq180Nco2fQQK8BS9tiZNMmAQAoFr8oSg0tXoeEXAMKac7rk53kMJimNPBfSt-Y0G6qJdlywZy008zKvJGxq_xZBnJQ)","ref":"readme.html"},{"type":"extras","title":"Features - EcspanseStateMachine","doc":"- Every entity can have a state machine executing simultaneously - create, start, and stop independently\n- Validation - all states must be defined and reachable\n- State changes on command or timeout\n- Observable: Events and Telemetry\n- Mermaid state diagram generation","ref":"readme.html#features"},{"type":"extras","title":"Installation - EcspanseStateMachine","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `ecspanse_state_machine` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ecspanse_state_machine, \"~> 0.3.2\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"How to Use - EcspanseStateMachine","doc":"1. [Systems Setup](#systems-setup)\n2. [Add a state machine](#add-a-state-machine)\n3. [Listen for state changes](#listen-for-state-changes)\n4. [Command a state change](#command-a-state-change)\n5. [Stopping a state machine](#stopping-a-state-machine)\n\n#","ref":"readme.html#how-to-use"},{"type":"extras","title":"Systems Setup - EcspanseStateMachine","doc":"As part of your ESCpanse setup, you will have defined a `manager` with a `setup(data)` function. In that function, chain a call to `ESCpanseStateMachine.setup`\n\n```elixir\n  def setup(data) do\n    data\n    # register the state machine's systems\n    |> EcspanseStateMachine.setup()\n\n    # Be sure to register the Ecspanse System Timer!\n    |> Ecspanse.add_frame_end_system(Ecspanse.System.Timer)\n\n    # register your systems too\n```\n\nECSpanseStateMachine will add the systems it needs for you.\n\n#","ref":"readme.html#systems-setup"},{"type":"extras","title":"Add a state machine - EcspanseStateMachine","doc":"The state machine is an ECSpanse component. You add it to your entity's spec in the components list. `EcspanseStateMachine.new` is a convenience API function to create the state machine component.\n\n1. Create a state machine component spec\n\n```elixir\n    state_machine =\n      EcspanseStateMachine.new(\n        :idle,\n        [\n          [name: :idle, exits: [:patrol, :fight], timeout: 5_000],\n          [name: :patrol, exits: [:fight, :idle], timeout: 10_000, default_exit: :idle],\n          [name: :fight, exits: [:idle, :die]],\n          [name: :die]\n        ]\n      )\n```\n\n2. Include the component in your entity\n\n```elixir\n    Ecspanse.Command.spawn_entity!({\n      Ecspanse.Entity,\n      components: [state_machine]\n    })\n```\n\n##","ref":"readme.html#add-a-state-machine"},{"type":"extras","title":"Defining States - EcspanseStateMachine","doc":"A state definition is a keyword list with the following keys. :name is the only required key but most states will also include :exits.\n\nStates that have at least one exit have a **default exit**. The default exit is the first exit in the :exits list unless specified by the :default_exit keyword.\n\nStates that have timeout will transition to the default exit. The Api provides a convenience function for transitioning to the default exit.\n\n- **:name** - A State must have a unique name (an atom or String).\n- **:exits** - Exits is a list of state names that can be transitioned to from this state. The majority of your states will have at least one value. Terminal states will not have any.\n- **:default_exit** - The state to transition to by default. The default exit must be in the list of exits.\n- **:timeout** - The number of milliseconds to be in this state before automatically transitioning to the default exit.\n\n###","ref":"readme.html#defining-states"},{"type":"extras","title":"Examples - EcspanseStateMachine","doc":"```elixir\n  # This is a terminal state since it has no exits.  The state machine will stop once it enters a terminal state.\n  [name: :die]\n\n  # The :fight state can transition to :idle or :die. You must call a transition function on the api to change from the :fight state since there is no :timeout.\n  [name: :fight, exits: [:idle, :die]],\n\n  # :idle can transition to :patrol or :fight.  You can use the api to transition to either state.\n  # After 5 seconds (the :timeout), the state will transition to :patrol.\n  # :patrol is the default exit state since it is first in the :exits list and :default_exit isn't specified\n  [name: :idle, exits: [:patrol, :fight], timeout: 5_000]\n\n  # :patrol can transition to :fight or :idle.  You can use the api to transition to either state.\n  # After 10 seconds (the :timeout), the state will transition to :idle.\n  # :idle is the default exit state since it is specified as the :default_exit.\n  [name: :patrol, exits: [:fight, :idle], timeout: 10_000, default_exit: :idle]\n```\n\n##","ref":"readme.html#examples"},{"type":"extras","title":"Starting your state machine - EcspanseStateMachine","doc":"The default behavior is to automatically start a state machine. If you don't want that behavior, then you can 'set auto_start to false' and call `EcspanseStateMachine.start` when you're ready.\n\nAuto start is an option, the third parameter to EcspanseStateMachine.new(). Here's an example of turning off auto_start and then starting the state machine later.\n\n```elixir\n  state_machine =\n    EcspanseStateMachine.new(\n      :idle,\n      [\n        [name: :idle, exits: [:patrol, :fight], timeout: 5_000],\n        [name: :patrol, exits: [:fight, :idle], timeout: 10_000, default_exit: :idle],\n        [name: :fight, exits: [:idle, :die]],\n        [name: :die]\n      ],\n      auto_start: false\n    )\n\n  entity = Ecspanse.Command.spawn_entity!({\n    Ecspanse.Entity,\n    components: [ state_machine]\n  })\n\n  # some time later\n  EcspanseStateMachine.start(entity.id)\n```\n\n#","ref":"readme.html#starting-your-state-machine"},{"type":"extras","title":"Listen for state changes - EcspanseStateMachine","doc":"ECSpanseStateMachine publishes `Started`, `Stopped`, and `StateChanged` events. State changed is the primary event. It's your chance to take action after a transition.\n\n```elixir\ndefmodule OnStateChanged do\n  use Ecspanse.System,\n    event_subscriptions: [EcspanseStateMachine.Events.StateChanged]\n\n  def run(\n        %EcspanseStateMachine.Events.StateChanged{\n          entity_id: entity_id,\n          from: from,\n          to: to,\n          trigger: _trigger\n        },\n        _frame\n      ) do\n      # respond to the transition\n  end\nend\n```\n\n#","ref":"readme.html#listen-for-state-changes"},{"type":"extras","title":"Command a state change - EcspanseStateMachine","doc":"State changes happen when a timeout elapses or upon request. Call `EcspanseStateMachine.transition` to trigger a transition.\n\n```elixir\n  EcspanseStateMachine.transition(entity_id, :fight, :idle)\n```\n\nHere were changing state from :fight to :idle.\n\n#","ref":"readme.html#command-a-state-change"},{"type":"extras","title":"Stopping a state machine - EcspanseStateMachine","doc":"The state machine will automatically stop when it reaches a state no exits.\n\nYou can stop a state machine anytime by calling `EcspanseStateMachine.stop`.\n\n```elixir\n  EcspanseStateMachine.stop(entity_id)\n```","ref":"readme.html#stopping-a-state-machine"},{"type":"extras","title":"Telemetry - EcspanseStateMachine","doc":"ECSpanse State Machine implements telemetry for the following events.\n\n| event name                         | measurement | metadata             | description                     |\n| ---------------------------------- | ----------- | -------------------- | ------------------------------- |\n| ecspanse_state_machine.start       | system_time | state_machine        | Executed on state machine start |\n| ecspanse_state_machine_stop        | duration    | state_machine        | Executed on state machine stop  |\n| ecspanse_state_machine.state.start | system_time | state_machine, state | Executed on entering a state    |\n| ecspanse_state_machine.state.stop  | duration    | state_machine, state | Executed on exiting a state     |","ref":"readme.html#telemetry"},{"type":"extras","title":"Mermaid State Diagrams - EcspanseStateMachine","doc":"ECSpanseStateMachine generates [Mermaid.js](https://mermaid.js.org/) state diagrams for your state machines.\n\n```elixir\n  EcspanseStateMachine.format_as_mermaid_diagram(entity_id)\n```\n\nHere's an example output.\n\n```\n---\ntitle: Simple AI\n---\nstateDiagram-v2\n[*] --> idle\nfight --> die\nfight --> idle\nidle --> fight\nidle --> patrol: ⏲️\npatrol --> fight\npatrol --> idle: ⏲️\ndie --> [*]\n```\n\nWhich produces the following state diagram when rendered\n\n[![](https://mermaid.ink/img/pako:eNpVkD0OwjAMha8SeURkYcyAhMTCwMSIGSLilojErYKLhFDP0LswcR4uwBUI6UBZLH_Pz_LPHY6NIzCgtUYWL4GM2vnYBlKrDXKRL2KF1t7WyUZ9XSDvZwel9VJ5Fwi58vVJCjv_h2P5GwuWwoRbK6kJRr2Gx_s5II88tU6Ub9fPmgcVNS8Cc4iUovUuX3FHVgpBThQJweTU2XRGQO6zz3bS7G58BCOpozl0rfsdBqay4ZJVcl6atB3fUr7TfwD9smWR?type=png)](https://mermaid.live/edit#pako:eNpVkD0OwjAMha8SeURkYcyAhMTCwMSIGSLilojErYKLhFDP0LswcR4uwBUI6UBZLH_Pz_LPHY6NIzCgtUYWL4GM2vnYBlKrDXKRL2KF1t7WyUZ9XSDvZwel9VJ5Fwi58vVJCjv_h2P5GwuWwoRbK6kJRr2Gx_s5II88tU6Ub9fPmgcVNS8Cc4iUovUuX3FHVgpBThQJweTU2XRGQO6zz3bS7G58BCOpozl0rfsdBqay4ZJVcl6atB3fUr7TfwD9smWR)","ref":"readme.html#mermaid-state-diagrams"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}